/*
 * Copyright 2002-2004 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.appfuse.richclient;

import java.awt.Dimension;

import org.springframework.richclient.application.ApplicationWindow;
import org.springframework.richclient.application.config.ApplicationWindowConfigurer;
import org.springframework.richclient.application.config.DefaultApplicationLifecycleAdvisor;
import org.springframework.richclient.application.setup.SetupWizard;
import org.springframework.richclient.command.ActionCommand;
import org.springframework.richclient.preference.PreferenceStore;
import org.appfuse.richclient.ui.preference.CompositeDialogPageType;
import org.appfuse.richclient.ui.preference.PetClinicAppearance;

/**
 * Custom application lifecycle implementation that configures the petclinic app
 * at well defined points within its lifecycle.
 * 
 * @author Keith Donald
 */
public class PetClinicLifecycleAdvisor extends
        DefaultApplicationLifecycleAdvisor {
    public void onPreWindowOpen(ApplicationWindowConfigurer configurer) {
//        super.onPreWindowOpen(configurer);
//                if (getApplicationServices().containsBean("setupWizard")) {
//                    SetupWizard setupWizard =
//         (SetupWizard)getApplicationServices().getBean("setupWizard",
//         SetupWizard.class);
//                    setupWizard.execute();
//                }
//         comment out to hide the menubar, toolbar, or reduce window size...
//        configurer.setShowMenuBar(false);
//        configurer.setShowToolBar(false);
//        configurer.setInitialSize(new Dimension(640, 480));
    }

    public void onCommandsCreated(ApplicationWindow window) {
        initializeDefaultPreferences();

        ActionCommand command = window.getCommandManager().getActionCommand(
                "loginCommand");
        command.execute();
    }

    private void initializeDefaultPreferences() {
        PreferenceStore ps = (PreferenceStore) getApplicationServices()
                .getBean("preferenceStore");
        ps.setDefault(PetClinicAppearance.DIALOG_PAGE_TYPE,
                CompositeDialogPageType.TREE);
    }

}