/*
 * Copyright 2002-2004 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.appfuse.richclient.ui.binder;

import java.util.Iterator;
import java.util.Map;

import org.springframework.richclient.form.binding.Binder;
import org.springframework.richclient.form.binding.swing.SwingBinderSelectionStrategy;

/** 
 * @author Oliver Hutchison
 */
public class PetClinicBinderSelectionStrategy extends SwingBinderSelectionStrategy {
    
    public void setBindersForPropertyTypes(Map binders) {
        for (Iterator i = binders.entrySet().iterator(); i.hasNext();) {
            Map.Entry entry = (Map.Entry)i.next();
            registerBinderForPropertyType((Class)entry.getKey(), (Binder)entry.getValue());
        }
    }
}
